#!/usr/bin/env node
"use strict";
/**
 * internal-dependencies
 * Calculate package dependencies living in the same monorepo
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const A = __importStar(require("fp-ts/Array"));
const E = __importStar(require("fp-ts/Either"));
const O = __importStar(require("fp-ts/Option"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const IO = __importStar(require("fp-ts/IO"));
const Console = __importStar(require("fp-ts/Console"));
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const Ord_1 = require("fp-ts/Ord");
const shades_1 = require("shades");
const ts_pattern_1 = require("ts-pattern");
const pipeable_1 = require("fp-ts/pipeable");
const function_1 = require("fp-ts/function");
const dependency_graph_1 = require("@typescript-tools/dependency-graph");
const io_ts_docopt_1 = require("io-ts-docopt");
const PackageName_1 = require("@typescript-tools/io-ts/dist/lib/PackageName");
const docstring = `
Usage:
    internal-dependencies [--path] <root> <package>...

Options:
    root        Root of lerna mono-repository
    packages    Packages to print dependencies of (also reads from stdin)
    --path      Print the relative path to each package from root
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.type({
    '<root>': t.string,
    '<package>': t.array(PackageName_1.PackageName),
    '--path': t.boolean
}), a => ({
    root: a['<root>'],
    packages: a['<package>'],
    mode: a['--path'] ? 'path' : 'name'
}));
const unary = (f) => (a) => f(a);
// Widens the type of a particular Err into an Err
const error = (error) => error;
const decodeDocopt = (codec, docstring, options) => pipeable_1.pipe(io_ts_docopt_1.decodeDocopt(codec, docstring, options), E.mapLeft((err) => ({ type: 'docopt decode', err: PathReporter.failure(err).join('\n') })), TE.fromEither);
const dependencyGraph = function_1.flow(dependency_graph_1.dependencyGraph, TE.mapLeft(error));
function main() {
    pipeable_1.pipe(decodeDocopt(CommandLineOptions, docstring, {
        argv: [
            ...process.argv.slice(2),
            // file descriptor '0' is stdin
            ...!process.stdin.isTTY ? fs.readFileSync(0, 'utf-8').trim().split('\n') : []
        ]
    }), TE.chain(options => pipeable_1.pipe(dependencyGraph(options.root), TE.map(graph => pipeable_1.pipe(options.packages, A.chain(pkg => pipeable_1.pipe(O.fromNullable(graph.get(pkg)), O.getOrElseW(function_1.constant(A.empty)))))), TE.map(dependencies => ts_pattern_1.match(options.mode)
        .with('path', () => dependencies
        .map(shades_1.get('location'))
        .map(location => path.relative(options.root, location)))
        .otherwise(() => dependencies.map(shades_1.get('name')))), TE.map(A.uniq(Ord_1.ordString)), TE.map((dependencies) => dependencies.forEach(unary(console.log))))), TE.fold(function_1.flow(Console.error, IO.chain(() => process.exit(1)), T.fromIO), function_1.constant(T.of(undefined))));
}
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=index.js.map